/* This file was generated by ODB, object-relational mapping (ORM)
 * compiler for C++.
 */

DROP TABLE IF EXISTS "package_other_repositories" CASCADE;

DROP TABLE IF EXISTS "package_requirement_alternatives" CASCADE;

DROP TABLE IF EXISTS "package_requirements" CASCADE;

DROP TABLE IF EXISTS "package_dependency_alternatives" CASCADE;

DROP TABLE IF EXISTS "package_dependencies" CASCADE;

DROP TABLE IF EXISTS "package_tags" CASCADE;

DROP TABLE IF EXISTS "package_licenses" CASCADE;

DROP TABLE IF EXISTS "package_license_alternatives" CASCADE;

DROP TABLE IF EXISTS "package" CASCADE;

DROP TABLE IF EXISTS "repository_prerequisites" CASCADE;

DROP TABLE IF EXISTS "repository_complements" CASCADE;

DROP TABLE IF EXISTS "repository" CASCADE;

CREATE TABLE "repository" (
  "name" TEXT NOT NULL PRIMARY KEY,
  "location" TEXT NOT NULL,
  "display_name" TEXT NOT NULL,
  "priority" SMALLINT NOT NULL,
  "url" TEXT NULL,
  "email" TEXT NULL,
  "summary" TEXT NULL,
  "description" TEXT NULL,
  "local_path" TEXT NOT NULL,
  "packages_timestamp" BIGINT NOT NULL,
  "repositories_timestamp" BIGINT NOT NULL,
  "internal" BOOLEAN NOT NULL);

CREATE TABLE "repository_complements" (
  "repository" TEXT NOT NULL,
  "index" BIGINT NOT NULL,
  "complement" TEXT NOT NULL,
  CONSTRAINT "repository_fk"
    FOREIGN KEY ("repository")
    REFERENCES "repository" ("name")
    ON DELETE CASCADE,
  CONSTRAINT "complement_fk"
    FOREIGN KEY ("complement")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "repository_complements_repository_i"
  ON "repository_complements" ("repository");

CREATE INDEX "repository_complements_index_i"
  ON "repository_complements" ("index");

CREATE TABLE "repository_prerequisites" (
  "repository" TEXT NOT NULL,
  "index" BIGINT NOT NULL,
  "prerequisite" TEXT NOT NULL,
  CONSTRAINT "repository_fk"
    FOREIGN KEY ("repository")
    REFERENCES "repository" ("name")
    ON DELETE CASCADE,
  CONSTRAINT "prerequisite_fk"
    FOREIGN KEY ("prerequisite")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "repository_prerequisites_repository_i"
  ON "repository_prerequisites" ("repository");

CREATE INDEX "repository_prerequisites_index_i"
  ON "repository_prerequisites" ("index");

CREATE TABLE "package" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "version_upstream" TEXT NOT NULL,
  "priority" INTEGER NOT NULL,
  "priority_comment" TEXT NOT NULL,
  "summary" TEXT NOT NULL,
  "description" TEXT NULL,
  "changes" TEXT NOT NULL,
  "url" TEXT NOT NULL,
  "url_comment" TEXT NOT NULL,
  "package_url" TEXT NULL,
  "package_url_comment" TEXT NULL,
  "email" TEXT NOT NULL,
  "email_comment" TEXT NOT NULL,
  "package_email" TEXT NULL,
  "package_email_comment" TEXT NULL,
  "internal_repository" TEXT NULL,
  "location" TEXT NULL,
  "search_index" tsvector NULL,
  PRIMARY KEY ("name",
               "version_epoch",
               "version_canonical_upstream",
               "version_revision"),
  CONSTRAINT "internal_repository_fk"
    FOREIGN KEY ("internal_repository")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "package_search_index_i"
  ON "package" USING GIN ("search_index");

CREATE TABLE "package_license_alternatives" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "index" BIGINT NOT NULL,
  "comment" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_license_alternatives_object_id_i"
  ON "package_license_alternatives" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE INDEX "package_license_alternatives_index_i"
  ON "package_license_alternatives" ("index");

CREATE TABLE "package_licenses" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "alternative_index" BIGINT NOT NULL,
  "index" BIGINT NOT NULL,
  "license" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_licenses_object_id_i"
  ON "package_licenses" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE TABLE "package_tags" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "index" BIGINT NOT NULL,
  "tag" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_tags_object_id_i"
  ON "package_tags" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE INDEX "package_tags_index_i"
  ON "package_tags" ("index");

CREATE TABLE "package_dependencies" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "index" BIGINT NOT NULL,
  "conditional" BOOLEAN NOT NULL,
  "comment" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_dependencies_object_id_i"
  ON "package_dependencies" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE INDEX "package_dependencies_index_i"
  ON "package_dependencies" ("index");

CREATE TABLE "package_dependency_alternatives" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "dependency_index" BIGINT NOT NULL,
  "index" BIGINT NOT NULL,
  "dep_name" TEXT NOT NULL,
  "dep_version_epoch" SMALLINT NOT NULL,
  "dep_version_canonical_upstream" TEXT NOT NULL,
  "dep_version_revision" SMALLINT NOT NULL,
  "dep_constraint" TEXT NULL,
  "dep_constraint_epoch" SMALLINT NULL,
  "dep_constraint_canonical_upstream" TEXT NULL,
  "dep_constraint_revision" SMALLINT NULL,
  "dep_constraint_upstream" TEXT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE,
  CONSTRAINT "dep_package_fk"
    FOREIGN KEY ("dep_name",
                 "dep_version_epoch",
                 "dep_version_canonical_upstream",
                 "dep_version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    INITIALLY DEFERRED);

CREATE INDEX "package_dependency_alternatives_object_id_i"
  ON "package_dependency_alternatives" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE TABLE "package_requirements" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "index" BIGINT NOT NULL,
  "conditional" BOOLEAN NOT NULL,
  "comment" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_requirements_object_id_i"
  ON "package_requirements" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE INDEX "package_requirements_index_i"
  ON "package_requirements" ("index");

CREATE TABLE "package_requirement_alternatives" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "requirement_index" BIGINT NOT NULL,
  "index" BIGINT NOT NULL,
  "id" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_requirement_alternatives_object_id_i"
  ON "package_requirement_alternatives" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE TABLE "package_other_repositories" (
  "name" TEXT NOT NULL,
  "version_epoch" SMALLINT NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_revision" SMALLINT NOT NULL,
  "index" BIGINT NOT NULL,
  "repository" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_revision")
    ON DELETE CASCADE,
  CONSTRAINT "repository_fk"
    FOREIGN KEY ("repository")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "package_other_repositories_object_id_i"
  ON "package_other_repositories" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_revision");

CREATE INDEX "package_other_repositories_index_i"
  ON "package_other_repositories" ("index");

/* Begin epilogue.
 */
DROP TYPE IF EXISTS weighted_text CASCADE;
CREATE TYPE weighted_text AS (a TEXT, b TEXT, c TEXT, d TEXT);

DROP FUNCTION IF EXISTS to_tsvector(IN document weighted_text);
DROP FUNCTION IF EXISTS search_packages(IN query tsquery, INOUT name TEXT);
DROP FUNCTION IF EXISTS search_latest_packages(IN query tsquery);
DROP FUNCTION IF EXISTS latest_package(INOUT name TEXT);
DROP FUNCTION IF EXISTS latest_packages();

-- Return the latest versions of internal packages as a set of package rows.
--
CREATE FUNCTION
latest_packages()
RETURNS SETOF package AS $$
  SELECT p1.*
  FROM package p1 LEFT JOIN package p2 ON (
    p1.internal_repository IS NOT NULL AND p1.name = p2.name AND
    p2.internal_repository IS NOT NULL AND
    (p1.version_epoch < p2.version_epoch OR
     p1.version_epoch = p2.version_epoch AND
     (p1.version_canonical_upstream < p2.version_canonical_upstream OR
      p1.version_canonical_upstream = p2.version_canonical_upstream AND
      p1.version_revision < p2.version_revision)))
  WHERE
    p1.internal_repository IS NOT NULL AND p2.name IS NULL;
$$ LANGUAGE SQL STABLE;

-- Find the latest version of an internal package having the specified name.
-- Return a single row containing the package id, empty row set if the package
-- not found.
--
CREATE FUNCTION
latest_package(INOUT name TEXT,
               OUT version_epoch SMALLINT,
               OUT version_canonical_upstream TEXT,
               OUT version_revision SMALLINT)
RETURNS SETOF record AS $$
  SELECT name, version_epoch, version_canonical_upstream, version_revision
  FROM latest_packages()
  WHERE name = latest_package.name;
$$ LANGUAGE SQL STABLE;

-- Search for the latest version of an internal packages matching the specified
-- search query. Return a set of rows containing the package id and search
-- rank. If query is NULL, then match all packages and return 0 rank for
-- all rows.
--
CREATE FUNCTION
search_latest_packages(IN query tsquery,
                       OUT name TEXT,
                       OUT version_epoch SMALLINT,
                       OUT version_canonical_upstream TEXT,
                       OUT version_revision SMALLINT,
                       OUT rank real)
RETURNS SETOF record AS $$
  SELECT name, version_epoch, version_canonical_upstream, version_revision,
         CASE
	   WHEN query IS NULL THEN 0
-- Weight mapping:           D     C    B    A
	   ELSE ts_rank_cd('{0.05, 0.2, 0.9, 1.0}', search_index, query)
	 END AS rank
  FROM latest_packages()
  WHERE query IS NULL OR search_index @@ query;
$$ LANGUAGE SQL STABLE;

-- Search for packages matching the search query and having the specified name.
-- Return a set of rows containing the package id and search rank. If query
-- is NULL, then match all packages and return 0 rank for all rows.
-- 
CREATE FUNCTION
search_packages(IN query tsquery,             
                INOUT name TEXT,
                OUT version_epoch SMALLINT,
                OUT version_canonical_upstream TEXT,
                OUT version_revision SMALLINT,
                OUT rank real)
RETURNS SETOF record AS $$
  SELECT name, version_epoch, version_canonical_upstream, version_revision,
         CASE
	   WHEN query IS NULL THEN 0
-- Weight mapping:           D     C    B    A
	   ELSE ts_rank_cd('{0.05, 0.2, 0.9, 1.0}', search_index, query)
	 END AS rank
  FROM package
  WHERE
  internal_repository IS NOT NULL AND name = search_packages.name AND
  (query IS NULL OR search_index @@ query);
$$ LANGUAGE SQL STABLE;

-- Parse weighted_text to tsvector.
--
CREATE FUNCTION
to_tsvector(IN document weighted_text)
RETURNS tsvector AS $$
  SELECT
    CASE
      WHEN document IS NULL THEN NULL
      ELSE
        setweight(to_tsvector(document.a), 'A') ||
	setweight(to_tsvector(document.b), 'B') ||
	setweight(to_tsvector(document.c), 'C') ||
	setweight(to_tsvector(document.d), 'D')
    END
$$ LANGUAGE SQL IMMUTABLE;
/*
 * End epilogue. */

